Index: LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2413)
+++ LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2414)
@@ -202,4 +202,5 @@
     LOGICAL, SAVE :: ok_conserv_q_omp
     INTEGER, SAVE :: iflag_fisrtilp_qsat_omp
+    INTEGER, SAVE :: iflag_bergeron_omp
     LOGICAL,SAVE :: ok_strato_omp
     LOGICAL,SAVE :: ok_hines_omp, ok_gwd_rando_omp
@@ -754,11 +755,19 @@
 
     !Config  Key  = iflag_fisrtilp_qsat
-    !Config  Desc = Flag de convection
-    !Config  Def  = 1
-    !Config  Help = Flag  pour la convection les options suivantes existent :
-    !Config         -1 pour Kinetic energy correction
-    !Config         1  conservation kinetic and enthalpy
+    !Config  Desc = Flag de fisrtilp
+    !Config  Def  = 0
+    !Config  Help = Flag  pour la pluie grande-échelle les options suivantes existent :
+    !Config         >1 nb iterations pour converger dans le calcul de qsat
     iflag_fisrtilp_qsat_omp = 0
     CALL getin('iflag_fisrtilp_qsat',iflag_fisrtilp_qsat_omp)
+
+    !Config  Key  = iflag_bergeron
+    !Config  Desc = Flag de fisrtilp
+    !Config  Def  = 0
+    !Config  Help = Flag  pour la pluie grande-échelle les options suivantes existent :
+    !Config         0 pas d effet Bergeron
+    !Config         1 effet Bergeron pour T<0
+    iflag_bergeron_omp = 0
+    CALL getin('iflag_bergeron',iflag_bergeron_omp)
 
     !
@@ -1958,4 +1967,5 @@
     ok_conserv_q = ok_conserv_q_omp
     iflag_fisrtilp_qsat = iflag_fisrtilp_qsat_omp
+    iflag_bergeron = iflag_bergeron_omp
 
     epmax = epmax_omp
@@ -2228,4 +2238,5 @@
     write(lunout,*)'ok_conserv_q=',ok_conserv_q
     write(lunout,*)'iflag_fisrtilp_qsat=',iflag_fisrtilp_qsat
+    write(lunout,*)'iflag_bergeron=',iflag_bergeron
     write(lunout,*)' epmax = ', epmax
     write(lunout,*)' ok_adj_ema = ', ok_adj_ema
Index: LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2413)
+++ LMDZ5/branches/testing/libf/phylmd/fisrtilp.F90	(revision 2414)
@@ -123,4 +123,6 @@
   PARAMETER (ztfondue=278.15)
   REAL dzfice(klon)
+  REAL zsolid
+  
   !
   LOGICAL appel1er
@@ -932,9 +934,19 @@
                *(paprs(i,k)-paprs(i,k+1))/(RG*dtime) 
            zifl(i) = zifl(i)+ MAX(zcond(i)*zfice(i)-zoliqi(i),0.0) &
-                    *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)  
+                    *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)
      !      zrfl(i) = zrfl(i)+  zpluie                         &
      !          *(paprs(i,k)-paprs(i,k+1))/(RG*dtime) 
      !      zifl(i) = zifl(i)+  zice                    &
-     !               *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)                                    
+     !               *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)
+         
+!CR : on prend en compte l'effet Bergeron dans les flux de precipitation
+           if ((iflag_bergeron.eq.1).and.(zt(i).LT.273.15)) then
+              zsolid = zrfl(i)
+              zifl(i) = zifl(i)+zrfl(i)
+              zrfl(i) = 0.
+              zt(i)=zt(i)+zsolid*(RG*dtime)/(paprs(i,k)-paprs(i,k+1)) &
+                      *(RLSTT-RLVTT)/RCPD/(1.0+RVTMP2*zq(i))
+           endif
+!RC                                    
 
          ENDIF                      
Index: LMDZ5/branches/testing/libf/phylmd/fisrtilp.h
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/fisrtilp.h	(revision 2413)
+++ LMDZ5/branches/testing/libf/phylmd/fisrtilp.h	(revision 2414)
@@ -15,4 +15,5 @@
       INTEGER iflag_pdf
       INTEGER iflag_fisrtilp_qsat
+      INTEGER iflag_bergeron
 
       common/comfisrtilp/                                               &
@@ -26,4 +27,5 @@
      &     ,reevap_ice                                                  &
      &     ,iflag_fisrtilp_qsat                                         &
+     &     ,iflag_bergeron                                              &
      &     ,iflag_pdf        
 