Index: LMDZ5/trunk/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90
===================================================================
--- LMDZ5/trunk/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90	(revision 2420)
+++ LMDZ5/trunk/libf/dynphy_lonlat/phylmd/callphysiq_mod.F90	(revision 2421)
@@ -89,6 +89,5 @@
               zdtfi_omp,      &
               zdqfi_omp,      &
-              zdpsrf_omp,     &
-              pducov)
+              zdpsrf_omp)
 
 
Index: LMDZ5/trunk/libf/phylmd/dyn1d/lmdz1d.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/dyn1d/lmdz1d.F90	(revision 2420)
+++ LMDZ5/trunk/libf/phylmd/dyn1d/lmdz1d.F90	(revision 2421)
@@ -243,7 +243,4 @@
       integer :: k,l,i,it=1,mxcalc
       integer jcode
-      integer jjmp1
-      parameter (jjmp1=jjm+1-1/jjm)
-      REAL dudyn(iim+1,jjmp1,llm)
       INTEGER read_climoz 
 !Al1
@@ -940,6 +937,5 @@
             plev,play,phi,phis,presnivs, &
             u,v, rot, temp,q,omega2, &
-            du_phys,dv_phys,dt_phys,dq,dpsrf, &
-            dudyn)
+            du_phys,dv_phys,dt_phys,dq,dpsrf)
         firstcall=.false.
 
Index: LMDZ5/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/physiq_mod.F90	(revision 2420)
+++ LMDZ5/trunk/libf/phylmd/physiq_mod.F90	(revision 2421)
@@ -14,6 +14,5 @@
      u,v,rot,t,qx, &
      flxmass_w, &
-     d_u, d_v, d_t, d_qx, d_ps &
-     , dudyn)
+     d_u, d_v, d_t, d_qx, d_ps)
 
   USE ioipsl, only: histbeg, histvert, histdef, histend, histsync, &
@@ -720,9 +719,6 @@
 !  PARAMETER(imp1jmp1=(iim+1)*jjmp1)
   !ym A voir plus tard
-  REAL zx_tmp((nbp_lon+1)*nbp_lat)
-  REAL airedyn(nbp_lon+1,nbp_lat)
-  REAL padyn(nbp_lon+1,nbp_lat,klev+1)
-  REAL dudyn(nbp_lon+1,nbp_lat,klev)
-  REAL rlatdyn(nbp_lon+1,nbp_lat)
+!  REAL zx_tmp((nbp_lon+1)*nbp_lat)
+!  REAL airedyn(nbp_lon+1,nbp_lat)
   !IM 190504 END
   LOGICAL ok_msk
Index: LMDZ5/trunk/libf/phylmd/write_histday_seri.h
===================================================================
--- LMDZ5/trunk/libf/phylmd/write_histday_seri.h	(revision 2420)
+++ LMDZ5/trunk/libf/phylmd/write_histday_seri.h	(revision 2421)
@@ -52,85 +52,8 @@
                      zx_tmp_2d,nbp_lon*nbp_lat,ndex2d) 
 !
-!IM 151004 BEG
-      IF(1.EQ.0) THEN
-!
-      DO k=1, klev
-      DO i=1, klon
-       zx_tmp_fi3d(i,k)=u_seri(i,k)*RA*cos(pir*latitude_deg(i))
-      ENDDO
-      ENDDO
-!
-      CALL moyglo_pondaima(klon, klev, zx_tmp_fi3d,  &
-           cell_area, paprs, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day_seri,"momang",itau_w,zx_tmp_2d, &
-                     nbp_lon*nbp_lat,ndex2d)
-!
-! friction torque
-!
-      DO i=1, klon
-       zx_tmp_fi2d(i)=zxfluxu(i,1)*RA* cos(pir*latitude_deg(i))
-      ENDDO
-!
-      ok_msk=.FALSE.
-      CALL moyglo_pondaire(klon, zx_tmp_fi2d, cell_area,  &
-           ok_msk, msk, moyglo)
-      zx_tmp_fi2d(1:klon)=moyglo
-!
-      CALL gr_fi_ecrit(1, klon,nbp_lon,nbp_lat, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day_seri,"frictor",itau_w,zx_tmp_2d, &
-                     nbp_lon*nbp_lat,ndex2d)
-!
-! mountain torque
-!
-!IM 190504 BEG
-      CALL gr_fi_dyn(1,klon,nbp_lon+1,nbp_lat,cell_area,airedyn)
-      CALL gr_fi_dyn(klev+1,klon,nbp_lon+1,nbp_lat,paprs,padyn)
-      CALL gr_fi_dyn(1,klon,nbp_lon+1,nbp_lat,latitude_deg,rlatdyn)
-      mountor=0.
-      airetot=0.
-      DO j = 1, nbp_lat
-       DO i = 1, nbp_lon+1
-        ij=i+(nbp_lon+1)*(j-1)
-        zx_tmp(ij)=0.
-        DO k = 1, klev
-         zx_tmp(ij)=zx_tmp(ij)+dudyn(i,j,k)*airedyn(i,j)* &
-                    (padyn(i,j,k+1)-padyn(i,j,k))/RG
-         airetot=airetot+airedyn(i,j)
-        ENDDO
-!IM 190504 mountor=mountor+zx_tmp(ij)*airedyn(i,j)*RA*
-        mountor=mountor+zx_tmp(ij)*RA* &
-                 cos(pir* rlatdyn(i,j))
-       ENDDO
-      ENDDO
-!IM 151004 BEG
-      IF(itap.EQ.1) PRINT*,'airetot=',airetot,airetot/klev
-!IM 151004 END
-!IM 190504      mountor=mountor/(airetot*airetot)
-      mountor=mountor/airetot
-!
-!IM 190504 END
-      zx_tmp_2d(1:nbp_lon,1:nbp_lat)=mountor
-      CALL histwrite(nid_day_seri,"mountor",itau_w,zx_tmp_2d, &
-                     nbp_lon*nbp_lat,ndex2d)
-!
-      ENDIF !(1.EQ.0) THEN
 !
 !
-      CALL gr_fi_dyn(1,klon,nbp_lon+1,nbp_lat,cell_area,airedyn)
       CALL gr_fi_ecrit(1,klon,nbp_lon,nbp_lat,cell_area,zx_tmp_2d)
       airetot=0.
-!     DO j = 1, nbp_lat
-!      DO i = 1, nbp_lon+1
-!       ij=i+(nbp_lon+1)*(j-1)
-!       DO k = 1, klev
-!        airetot=airetot+airedyn(i,j)
-!        airetot=airetot+airedyn(i,j)
-!       ENDDO !k
-!      ENDDO !i
-!     ENDDO !j
-!
       DO i=1, klon
        airetot=airetot+cell_area(i)