Index: LMDZ5/trunk/libf/phylmd/atm2geo.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/atm2geo.F90	(revision 2428)
+++ LMDZ5/trunk/libf/phylmd/atm2geo.F90	(revision 2429)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 SUBROUTINE atm2geo ( im, jm, pte, ptn, plon, plat, pxx, pyy, pzz )
@@ -32,5 +32,5 @@
   
 ! Value at North Pole  
-  IF (is_north_pole) THEN
+  IF (is_north_pole_dyn) THEN
      pxx(:, 1) = - pte (1, 1)
      pyy(:, 1) = - ptn (1, 1) 
@@ -39,5 +39,5 @@
 
 ! Value at South Pole
-  IF (is_south_pole) THEN
+  IF (is_south_pole_dyn) THEN
      pxx(:,jm) = pxx(1,jm)
      pyy(:,jm) = pyy(1,jm)
Index: LMDZ5/trunk/libf/phylmd/cpl_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/cpl_mod.F90	(revision 2428)
+++ LMDZ5/trunk/libf/phylmd/cpl_mod.F90	(revision 2429)
@@ -1115,5 +1115,5 @@
     
       IF (is_parallel) THEN
-         IF (.NOT. is_north_pole) THEN
+         IF (.NOT. is_north_pole_dyn) THEN
 #ifdef CPP_MPI
             CALL MPI_RECV(Up,1,MPI_REAL_LMDZ,mpi_rank-1,1234,COMM_LMDZ_PHY,status,error)
@@ -1122,5 +1122,5 @@
          ENDIF
        
-         IF (.NOT. is_south_pole) THEN
+         IF (.NOT. is_south_pole_dyn) THEN
 #ifdef CPP_MPI
             CALL MPI_SEND(tmp_calv(1,jj_nb),1,MPI_REAL_LMDZ,mpi_rank+1,1234,COMM_LMDZ_PHY,error)
@@ -1129,10 +1129,10 @@
          ENDIF
          
-         IF (.NOT. is_north_pole .AND. ii_begin /=1) THEN
+         IF (.NOT. is_north_pole_dyn .AND. ii_begin /=1) THEN
             Up=Up+tmp_calv(nbp_lon,1)
             tmp_calv(:,1)=Up
          ENDIF
          
-         IF (.NOT. is_south_pole .AND. ii_end /= nbp_lon) THEN
+         IF (.NOT. is_south_pole_dyn .AND. ii_end /= nbp_lon) THEN
             Down=Down+tmp_calv(1,jj_nb)
             tmp_calv(:,jj_nb)=Down	 
@@ -1222,6 +1222,6 @@
 
     IF (is_sequential) THEN
-       IF (is_north_pole) tmp_lon(:,1)     = tmp_lon(:,2)
-       IF (is_south_pole) tmp_lon(:,nbp_lat) = tmp_lon(:,nbp_lat-1)
+       IF (is_north_pole_dyn) tmp_lon(:,1)     = tmp_lon(:,2)
+       IF (is_south_pole_dyn) tmp_lon(:,nbp_lat) = tmp_lon(:,nbp_lat-1)
     ENDIF
       
@@ -1389,6 +1389,6 @@
     CALL Grid1Dto2D_mpi(temp_mpi,champ_out)
     
-    IF (is_north_pole) champ_out(:,1)=temp_mpi(1)
-    IF (is_south_pole) champ_out(:,jj_nb)=temp_mpi(klon)
+    IF (is_north_pole_dyn) champ_out(:,1)=temp_mpi(1)
+    IF (is_south_pole_dyn) champ_out(:,jj_nb)=temp_mpi(klon)
 !$OMP END MASTER
     
Index: LMDZ5/trunk/libf/phylmd/geo2atm.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/geo2atm.F90	(revision 2428)
+++ LMDZ5/trunk/libf/phylmd/geo2atm.F90	(revision 2429)
@@ -37,5 +37,5 @@
 
   ! Value at North Pole
-  IF (is_north_pole) THEN
+  IF (is_north_pole_dyn) THEN
      pu(:, 1) = -px (1,1)
      pv(:, 1) = -py (1,1)
@@ -44,5 +44,5 @@
   
   ! Value at South Pole     
-  IF (is_south_pole) THEN
+  IF (is_south_pole_dyn) THEN
      pu(:,jm) = -px (1,jm)
      pv(:,jm) = -py (1,jm)
Index: LMDZ5/trunk/libf/phylmd/iophy.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/iophy.F90	(revision 2428)
+++ LMDZ5/trunk/libf/phylmd/iophy.F90	(revision 2429)
@@ -44,5 +44,5 @@
                                 jj_nb, jj_begin, jj_end, ii_begin, ii_end, &
                                 mpi_size, mpi_rank, klon_mpi, &
-                                is_sequential, is_south_pole
+                                is_sequential, is_south_pole_dyn
   USE mod_grid_phy_lmdz, only: nbp_lon, nbp_lat, klon_glo
   USE print_control_mod, ONLY: prt_level,lunout 
@@ -144,5 +144,5 @@
       write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
       write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," data_ibegin=",data_ibegin," data_iend=",data_iend
-      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," is_south_pole=",is_south_pole
+      write(lunout,*) "init_iophy_new: mpirank=",mpi_rank," is_south_pole=",is_south_pole_dyn
     endif
 
@@ -151,5 +151,5 @@
                             1, nbp_lon, ii_begin, ii_end, jj_begin, jj_end,             &
                             klon_mpi+2*(nbp_lon-1), data_ibegin, data_iend,             &
-                            io_lat, io_lon,is_south_pole,mpi_rank)
+                            io_lat, io_lon,is_south_pole_dyn,mpi_rank)
 #endif
 !$OMP END MASTER
Index: LMDZ5/trunk/libf/phylmd/oasis.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/oasis.F90	(revision 2428)
+++ LMDZ5/trunk/libf/phylmd/oasis.F90	(revision 2429)
@@ -342,5 +342,5 @@
     
     istart=ii_begin
-    IF (is_south_pole) THEN
+    IF (is_south_pole_dyn) THEN
        iend=(jj_end-jj_begin)*nbp_lon+nbp_lon
     ELSE
@@ -408,5 +408,5 @@
 
     istart=ii_begin
-    IF (is_south_pole) THEN
+    IF (is_south_pole_dyn) THEN
        iend=(jj_end-jj_begin)*nbp_lon+nbp_lon
     ELSE
@@ -417,6 +417,6 @@
        wstart=istart
        wend=iend
-       IF (is_north_pole) wstart=istart+nbp_lon-1
-       IF (is_south_pole) wend=iend-nbp_lon+1
+       IF (is_north_pole_dyn) wstart=istart+nbp_lon-1
+       IF (is_south_pole_dyn) wend=iend-nbp_lon+1
        
        DO i = 1, maxsend
Index: LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 2428)
+++ LMDZ5/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 2429)
@@ -1,4 +1,4 @@
 !
-! $Header$
+! $Id$
 !
 MODULE phys_output_write_mod
@@ -25,4 +25,5 @@
 
     USE dimphy, only: klon, klev, klevp1, nslay
+    USE mod_phys_lmdz_para, ONLY: is_north_pole_phy,is_south_pole_phy
     USE mod_grid_phy_lmdz, ONLY : nbp_lon, nbp_lat
     USE time_phylmdz_mod, only: day_step_phy, start_time, itau_phy
@@ -348,5 +349,13 @@
 !!! Champs 1D !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        CALL histwrite_phy(o_phis, pphis)
-       CALL histwrite_phy(o_aire, cell_area)
+
+       zx_tmp_fi2d = cell_area
+       if (is_north_pole_phy) then
+         zx_tmp_fi2d(1) = cell_area(1)/nbp_lon
+       endif
+       if (is_south_pole_phy) then
+         zx_tmp_fi2d(klon) = cell_area(klon)/nbp_lon
+       endif
+       CALL histwrite_phy(o_aire, zx_tmp_fi2d)
 
        IF (vars_defined) THEN