Index: LMDZ5/trunk/libf/phylmd/dyn1d/1DUTILS.h
===================================================================
--- LMDZ5/trunk/libf/phylmd/dyn1d/1DUTILS.h	(revision 2465)
+++ LMDZ5/trunk/libf/phylmd/dyn1d/1DUTILS.h	(revision 2565)
@@ -3236,4 +3236,6 @@
      &           thlpcar(nlev_max),tracer(nlev_max,ntrac)
 
+        real height1(nlev_max)
+
         integer, parameter :: ilesfile=1
         integer :: ierr,k,itrac,nt1,nt2
@@ -3245,5 +3247,5 @@
         read (ilesfile,*) kmax
         do k=1,kmax
-          read (ilesfile,*) height(k),thlprof(k),qtprof (k),               &
+          read (ilesfile,*) height1(k),thlprof(k),qtprof (k),               &
      &                      uprof (k),vprof  (k),e12prof(k)
         enddo
@@ -3261,4 +3263,11 @@
           read (ilesfile,*) height(k),ugprof(k),vgprof(k),wfls(k),         &
      &                      dqtdxls(k),dqtdyls(k),dqtdtls(k),thlpcar(k)
+        end do
+        do k=1,kmax
+          if (height(k) .ne. height1(k)) then
+            print *, 'fichiers prof.inp et lscale.inp incompatibles :'
+            print *, 'les niveaux different : ',k,height1(k), height(k)
+            stop
+          endif
         end do
         close(ilesfile)
Index: LMDZ5/trunk/libf/phylmd/dyn1d/1D_interp_cases.h
===================================================================
--- LMDZ5/trunk/libf/phylmd/dyn1d/1D_interp_cases.h	(revision 2465)
+++ LMDZ5/trunk/libf/phylmd/dyn1d/1D_interp_cases.h	(revision 2565)
@@ -2,4 +2,13 @@
 ! $Id$
 !
+!---------------------------------------------------------------------
+! Forcing_LES case: constant dq_dyn
+!---------------------------------------------------------------------
+      if (forcing_LES) then
+        DO l = 1,llm
+          d_q_adv(l,1) = dq_dyn(l,1)
+        ENDDO
+      endif ! forcing_LES
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
 !---------------------------------------------------------------------
 ! Interpolation forcing in time and onto model levels
Index: LMDZ5/trunk/libf/phylmd/dyn1d/lmdz1d.F90
===================================================================
--- LMDZ5/trunk/libf/phylmd/dyn1d/lmdz1d.F90	(revision 2465)
+++ LMDZ5/trunk/libf/phylmd/dyn1d/lmdz1d.F90	(revision 2565)
@@ -33,5 +33,5 @@
    USE mod_1D_cases_read
    USE mod_1D_amma_read
-   USE print_control_mod, ONLY: prt_level
+   USE print_control_mod, ONLY: lunout, prt_level
    USE iniphysiq_mod, ONLY: iniphysiq
    USE mod_const_mpi, ONLY: comm_lmdz
@@ -54,4 +54,5 @@
 #include "fcg_gcssold.h"
 !!!#include "fbforcing.h"
+#include "compbl.h"
 
 !=====================================================================
@@ -242,4 +243,5 @@
 !---------------------------------------------------------------------
       integer :: k,l,i,it=1,mxcalc
+      integer :: nsrf
       integer jcode
       INTEGER read_climoz 
@@ -738,6 +740,14 @@
         t_ancien(1,:)=temp(:)
         q_ancien(1,:)=q(:,1)
-        pbl_tke(:,:,:)=1.e-8
-        wake_delta_pbl_tke(:,:,:)=0.
+!jyg<
+!!        pbl_tke(:,:,:)=1.e-8
+        pbl_tke(:,:,:)=0.
+        pbl_tke(:,2,:)=1.e-2
+        PRINT *, ' pbl_tke dans lmdz1d '
+       DO nsrf = 1,4
+         PRINT *,'pbl_tke(1,:,',nsrf,') ',pbl_tke(1,:,nsrf)
+       ENDDO
+
+!>jyg
 
         rain_fall=0.
@@ -762,5 +772,5 @@
         wake_deltaq = 0.
         wake_deltat = 0.
-        wake_delta_pbl_TKE = 0.
+        wake_delta_pbl_TKE(:,:,:) = 0.
         delta_tsurf = 0.
         wake_fip = 0.
@@ -791,7 +801,12 @@
 ! run_off_lic_0,pbl_tke(:,1:klev,nsrf), zmax0,f0,sig1,w01
 ! wake_deltat,wake_deltaq,wake_s,wake_cstar,wake_fip,wake_delta_pbl_tke(:,1:klev,nsrf)
+!
+! NB2: The content of the startphy.nc file depends on some flags defined in
+! the ".def" files. However, since conf_phys is not called in lmdz1d.F90, these flags have 
+! to be set at some arbitratry convenient values.
 !------------------------------------------------------------------------
 !Al1 =============== restart option ==========================
         if (.not.restart) then
+          iflag_pbl = 5
           call phyredem ("startphy.nc")
         else
@@ -1075,5 +1090,5 @@
 !---------------------------------------------------------------------
 
-      IF (nudge_tsoil) THEN
+      IF (nudge_tsoil .AND. .NOT. lastcall) THEN
        ftsoil(1,isoil_nudge,:) = ftsoil(1,isoil_nudge,:)                     &
      &  -timestep/tau_soil_nudge*(ftsoil(1,isoil_nudge,:)-Tsoil_nudge)